com.jogamp.newt.util.applet

## Class JOGLNewtAppletBase

- java.lang.Object
- - com.jogamp.newt.util.applet.JOGLNewtAppletBase

- All Implemented Interfaces:
    KeyListener, NEWTEventListener, EventListener, GLEventListener

      public class JOGLNewtAppletBase
      extends Object
      implements KeyListener, GLEventListener

  Shows how to deploy an applet using JOGL. This demo must be referenced from a web page via an <applet> tag.

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `DEBUG`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JOGLNewtAppletBase(String glEventListenerClazzName, int glSwapInterval, boolean noDefaultKeyListener, boolean glClosable, boolean glDebug, boolean glTrace)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static GLEventListener` | `createInstance(String clazzName)`
    `void` | `destroy()`
    `void` | `display(GLAutoDrawable drawable)` Called by the drawable to initiate OpenGL rendering by the client.
    `void` | `dispose(GLAutoDrawable drawable)` Notifies the listener to perform the release of all OpenGL resources per GLContext, such as memory buffers and GLSL programs.
    `Animator` | `getGLAnimator()`
    `GLEventListener` | `getGLEventListener()`
    `GLWindow` | `getGLWindow()`
    `void` | `init(GLAutoDrawable drawable)` Called by the drawable immediately after the OpenGL context is initialized.
    `void` | `init(GLWindow glWindow)`
    `void` | `init(ThreadGroup tg, GLWindow glWindow)`
    `boolean` | `isValid()`
    `void` | `keyPressed(KeyEvent e)` A key has been `pressed`, excluding `auto-repeat` `modifier` keys.
    `void` | `keyReleased(KeyEvent e)` A key has been `released`, excluding `auto-repeat` `modifier` keys.
    `void` | `reshape(GLAutoDrawable drawable, int x, int y, int width, int height)` Called by the drawable during the first repaint after the component has been resized.
    `static boolean` | `setField(Object instance, String fieldName, Object value)`
    `void` | `start()`
    `void` | `stop()`
    `static boolean` | `str2Bool(String str, boolean def)`
    `static int` | `str2Int(String str, int def)`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEBUG

          public static final boolean DEBUG

  - ### Constructor Detail

    - #### JOGLNewtAppletBase

          public JOGLNewtAppletBase(String glEventListenerClazzName,
                            int glSwapInterval,
                            boolean noDefaultKeyListener,
                            boolean glClosable,
                            boolean glDebug,
                            boolean glTrace)

  - ### Method Detail

    - #### getGLEventListener

          public GLEventListener getGLEventListener()

    - #### getGLWindow

          public GLWindow getGLWindow()

    - #### getGLAnimator

          public Animator getGLAnimator()

    - #### isValid

          public boolean isValid()

    - #### str2Bool

          public static boolean str2Bool(String str,
                         boolean def)

    - #### str2Int

          public static int str2Int(String str,
                    int def)

    - #### createInstance

          public static GLEventListener createInstance(String clazzName)

    - #### setField

          public static boolean setField(Object instance,
                         String fieldName,
                         Object value)

    - #### init

          public void init(GLWindow glWindow)

    - #### init

          public void init(ThreadGroup tg,
                  GLWindow glWindow)

    - #### start

          public void start()

    - #### stop

          public void stop()

    - #### destroy

          public void destroy()

    - #### init

          public void init(GLAutoDrawable drawable)

      Description copied from interface: `GLEventListener`
      Called by the drawable immediately after the OpenGL context is initialized. Can be used to perform one-time OpenGL initialization per GLContext, such as setup of lights and display lists.

      Note that this method may be called more than once if the underlying OpenGL context for the GLAutoDrawable is destroyed and recreated, for example if a GLCanvas is removed from the widget hierarchy and later added again.

      Specified by:
        `init` in interface `GLEventListener`

    - #### reshape

          public void reshape(GLAutoDrawable drawable,
                     int x,
                     int y,
                     int width,
                     int height)

      Description copied from interface: `GLEventListener`
      Called by the drawable during the first repaint after the component has been resized.

      The client can update it's viewport associated data and view volume of the window appropriately.

      For efficiency the GL viewport has already been updated via `glViewport(x, y, width, height)` when this method is called.

      Specified by:
        `reshape` in interface `GLEventListener`
      Parameters:
        `drawable` - the triggering `GLAutoDrawable`
        `x` - viewport x-coord in pixel units
        `y` - viewport y-coord in pixel units
        `width` - viewport width in pixel units
        `height` - viewport height in pixel units

    - #### display

          public void display(GLAutoDrawable drawable)

      Description copied from interface: `GLEventListener`
      Called by the drawable to initiate OpenGL rendering by the client. After all GLEventListeners have been notified of a display event, the drawable will swap its buffers if `setAutoSwapBufferMode` is enabled.
      Specified by:
        `display` in interface `GLEventListener`

    - #### dispose

          public void dispose(GLAutoDrawable drawable)

      Description copied from interface: `GLEventListener`
      Notifies the listener to perform the release of all OpenGL resources per GLContext, such as memory buffers and GLSL programs.

      Called by the drawable before the OpenGL context is destroyed by an external event, like a reconfiguration of the `GLAutoDrawable` closing an attached window, but also manually by calling `destroy`.

      Note that this event does not imply the end of life of the application. It could be produced with a followup call to `GLEventListener.init(GLAutoDrawable)` in case the GLContext has been recreated, e.g. due to a pixel configuration change in a multihead environment.

      Specified by:
        `dispose` in interface `GLEventListener`

    - #### keyPressed

          public void keyPressed(KeyEvent e)

      Description copied from interface: `KeyListener`
      A key has been `pressed`, excluding `auto-repeat` `modifier` keys. See `KeyEvent`.
      Specified by:
        `keyPressed` in interface `KeyListener`

    - #### keyReleased

          public void keyReleased(KeyEvent e)

      Description copied from interface: `KeyListener`
      A key has been `released`, excluding `auto-repeat` `modifier` keys. See `KeyEvent`.

      To simulated the removed `keyTyped(KeyEvent e)` semantics, simply apply the following constraints upfront and bail out if not matched, i.e.:

                  if( !e.isPrintableKey() || e.isAutoRepeat() ) {
                      return;
                  }

      Specified by:
        `keyReleased` in interface `KeyListener`

Copyright 2010 JogAmp Community.